{%- block comment -%}
  {%- from '_macros/icon.html.twig' import icon -%}
  {%- from '_macros/time.html.twig' import relative_time, relative_time_diff -%}
  {%- from 'vote/_macros.html.twig' import vote -%}
  <article class="comment
                  comment--{{ level > 1 ? 'nested' : 'top-level' }}
                  {{ show_context ? 'comment--with-context' }}
                  {{ comment.visibility is constant('App\\Entity\\Comment::VISIBILITY_DELETED') ? 'comment--soft-deleted' }}
                  hideable"
           id="comment_{{ comment.id }}"
           data-level="{{ level }}">
    <input type="checkbox" class="hideable__checkbox" id="comment_toggle_{{ comment.id }}" checked>

    {% if show_context %}
      {{- block('comment_context') -}}
    {% endif %}

    <div class="comment__row">
      <div class="comment__main">
        <header class="comment__header">
          <h1 class="comment__info break-text no-margin unheaderize">
            <span class="fg-muted text-sm">
              {{ 'comments.info'|trans({
                '%user%': block('comment_info_user'),
                '%timestamp%': relative_time(comment.timestamp, { natural: true }),
              })|raw }}

              {% if comment.editedAt %}
                <span class="comment__edited-at {{ comment.moderated ? 'comment__moderated' }} fg-muted text-sm">
                  {{ (comment.moderated ? 'comments.moderator_info' : 'comments.edit_info')|trans({
                    '%edited_at%': relative_time_diff(comment.editedAt, comment.timestamp, { natural: true }),
                  })|raw }}
                </span>
              {% endif %}
            </span>
          </h1>

          <ul class="nav no-margin unlistify">
            {% if post_numbers %}
              <li>
                <a href="{{ path('comment', { forum_name: comment.submission.forum.name, submission_id: comment.submission.id, comment_id: comment.id }) }}"
                   class="comment__info-link fg-grey">
                  <span class="text-sm">{{- 'number.id'|trans({ '%number%': comment.id|localizednumber }) -}}</span>
                </a>
              </li>
            {% endif %}

            <li>
              <label class="comment__info-link comment__hide-toggle hideable__toggle fg-grey no-wrap"
                     for="comment_toggle_{{ comment.id }}">
                <span class="hideable__indicator text-sm"
                      role="presentation"
                      data-hide-text="{{ 'action.hide'|trans }}"
                      data-unhide-text="{{ 'action.unhide'|trans }}"></span>
              </label>
            </li>
          </ul>
        </header>

        {%- if post_numbers and comment.parent -%}
          <p class="comment__replying-to hideable__hide">
            <a href="{{ path('submission', {
               forum_name: comment.submission.forum.name,
               submission_id: comment.submission.id,
               slug: comment.submission.title|slugify,
               commentView: 'linear'
            }) }}#comment_{{ comment.parent.id }}" class="fg-grey no-underline">
              {{- icon('forward') }}
              {{ 'comments.replying_to_comment'|trans({
                '%user%': '<span class="fg-muted">%s</span>'|format(comment.parent.user.username|e),
                '%id%': '<span class="fg-primary no-underline__exempt">%s</span>'|format(
                  'number.id'|trans({ '%number%': comment.parent.id|localizednumber|e })
                )
              })|raw -}}
            </a>
          </p>
        {%- endif -%}

        <div class="comment__body break-text hideable__hide">
          {%- if raw_body is not null -%}
            {{ raw_body|raw }}
          {%- elseif comment.body is not null -%}
            {{ comment.body|cached_markdown({ context: 'comment', comment: comment })|raw }}
          {%- endif -%}
        </div>

        <nav class="comment__nav hideable__hide">
          <ul class="fg-muted nav nav--guttered no-margin unlistify">
            {{- block('comment_nav') -}}
          </ul>
        </nav>

        {% if show_form and is_granted('ROLE_USER') %}
          {% from 'comment/_macros.html.twig' import comment_form %}
          {{ comment_form(comment.submission, comment) }}
        {% endif %}
      </div>

      <div class="comment__vote hideable__hide">
        {{ vote(comment, 'comment_vote') }}
      </div>
    </div>

    {% if recurse and comment.children|length > 0 %}
      <div class="comment__replies hideable__hide">
        {%- for reply in comment.children -%}
          {%- with { comment: reply, level: level + 1, show_form: false } -%}
            {{- block('comment') -}}
          {%- endwith -%}
        {%- endfor -%}
      </div>
    {% endif %}
  </article>
{%- endblock comment -%}

{% block comment_context %}
  {% with { submission: comment.submission, forum: comment.submission.forum } %}
    <div class="comment__context break-text text-sm">
      <p class="fg-muted">
        {{ (comment.parent ? 'comments.context.comment_reply' : 'comments.context.top_level_reply')|trans({
          '%comment_author%': block('comment_context_link_format')|format(
            path('user', { username: comment.user.username })|e,
            comment.user.username|e
          ),
          '%submission_title%': block('comment_context_link_format')|format(
            path('submission', {forum_name: forum.name, submission_id: submission.id})|e,
            submission.title|e
          ),
          '%submission_author%': block('comment_context_link_format')|format(
            path('user', { username: submission.user.username })|e,
            submission.user.username|e
          ),
        })|raw }}
    </div>
  {% endwith %}
{% endblock comment_context %}

{%- block comment_context_link_format -%}
  <a href="%s" class="fg-inherit"><strong>%s</strong></a>
{%- endblock -%}

{%- block comment_info_user -%}
  {%- from 'user/_macros.html.twig' import user_flag -%}

  {% apply spaceless %}
    {%- if comment.visibility is not constant('App\\Entity\\Comment::VISIBILITY_DELETED') -%}
      <a href="{{ path('user', { username: comment.user.username }) }}" class="fg-inherit">
        <strong>{{ comment.user.username }}</strong>
      </a>
    {%- else -%}
      {{- 'placeholder.deleted'|trans -}}
    {%- endif -%}
  {% endapply %}

  {% if comment.visibility is not constant('App\\Entity\\Comment::VISIBILITY_DELETED') and comment.user is same as(comment.submission.user) %}
    <small class="comment__op-text text-sm user-flag"
           title="{{ 'item.op'|trans }}"
           aria-label="{{ 'item.op'|trans }}">
      {{- 'item.op_abbr'|trans -}}
    </small>
  {% endif %}

  {{ user_flag(comment.userFlag) }}
{%- endblock comment_info_user -%}

{% block comment_nav %}
  {{ block('comment_nav_reply') }}

  {% if not post_numbers %}
    {{ block('comment_nav_permalink') }}
    {{ block('comment_nav_parent') }}
  {% endif %}

  {% if comment.user is same as(self) %}
    {% set comment_nav_classes = 'fg-inherit text-sm' %}
    {% if comment.children|length == 0 %}
      {{ block('comment_nav_delete_thread') }}
    {% endif %}
    {{- block('comment_nav_softdelete') -}}
    {{- block('comment_nav_edit') }}
  {% endif %}

  {% set menu_actions = block('comment_nav_menu_actions')|trim %}

  {% if menu_actions is not empty %}
    <li class="dropdown">
      <button class="dropdown__toggle fg-inherit no-underline text-sm unbuttonize">
        <span class="no-underline__exempt">{{ 'nav.actions'|trans }}</span>
        <span class="dropdown__arrow" aria-hidden="true"></span>
      </button>

      <ul class="dropdown__menu dropdown-card unlistify no-margin">
        {{ menu_actions|raw }}
      </ul>
    </li>
  {% endif %}
{% endblock comment_nav %}

{% block comment_nav_menu_actions %}
  {% set comment_nav_classes = 'menu-item no-wrap' %}
  {% if comment.user is not same as(self) %}
    {{ block('comment_nav_softdelete') }}
    {{ block('comment_nav_delete_thread') }}
    {{ block('comment_nav_edit') }}
    {{ block('comment_nav_ban') }}
    {{ block('comment_nav_ip_ban') }}
  {% elseif comment.children|length > 0 %}
    {{ block('comment_nav_delete_thread') }}
  {% endif %}
{% endblock %}

{%- block comment_nav_reply -%}
  {% if is_granted('ROLE_USER') %}
    <li>
      <a href="{{ path('comment', {
        forum_name: comment.submission.forum.name,
        submission_id: comment.submission.id,
        comment_id: comment.id
      }) }}" data-form-url="{{ path('comment_form', {
        forumName: comment.submission.forum.name,
        submissionId: comment.submission.id,
        commentId: comment.id
      }) }}" class="comment__reply-link text-sm">
        <strong>{{ 'comments.reply'|trans }}</strong>
      </a>
    </li>
  {% endif %}
{%- endblock comment_nav_reply -%}

{%- block comment_nav_permalink -%}
  {%- apply spaceless -%}
    <li>
      <a href="{{ path('comment', {
        forum_name: comment.submission.forum.name,
        submission_id: comment.submission.id,
        comment_id: comment.id
      }) }}" class="comment__permalink fg-inherit text-sm">{{ 'comments.permalink'|trans }}</a>
    </li>
  {%- endapply -%}
{%- endblock comment_nav_permalink -%}

{%- block comment_nav_parent -%}
  {%- apply spaceless -%}
    {%- if comment.parent -%}
      <li>
        <a href="{{ path('comment', {
          forum_name: comment.submission.forum.name,
          submission_id: comment.submission.id,
          comment_id: comment.parent.id
        }) }}" class="comment__parent-link fg-inherit text-sm">{{ 'comments.parent'|trans }}</a>
      </li>
    {%- endif -%}
  {%- endapply -%}
{%- endblock comment_nav_parent -%}

{% block comment_nav_softdelete %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('softdelete', comment) %}
    <li>
      <form action="{{ path('softdelete_comment', {
        forum_name: comment.submission.forum.name,
        submission_id: comment.submission.id,
        comment_id: comment.id,
      }) }}" method="POST">
        <input type="hidden" name="token" value="{{ csrf_token('softdelete_comment') }}">
        <button type="submit"
                class="unbuttonize comment__soft-delete-button {{ comment_nav_classes }} js-confirm-comment-delete">
          {{- 'menu-item' in comment_nav_classes ? icon('trash') }}
          {{ 'comments.delete'|trans -}}
        </button>
      </form>
    </li>
  {% endif %}
{% endblock comment_nav_softdelete %}

{%- block comment_nav_delete_thread -%}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('delete_thread', comment) %}
    <li>
      <form action="{{ path('delete_comment_thread', {
          forum_name: comment.submission.forum.name,
          submission_id: comment.submission.id,
          comment_id: comment.id,
      }) }}" method="POST">
        <input type="hidden" name="token" value="{{ csrf_token('delete_comment') }}">
        <button type="submit"
                class="unbuttonize comment__thread-delete-button {{ comment_nav_classes }} js-confirm-comment-delete">
          {{- 'menu-item' in comment_nav_classes ? icon('trash') }}
          {{ comment.children|length > 0 ? 'comments.delete_thread'|trans : 'comments.delete'|trans -}}
        </button>
      </form>
    </li>
  {% endif %}
{%- endblock comment_nav_delete_thread -%}

{%- block comment_nav_edit -%}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('edit', comment) %}
    <li>
      <a href="{{ path('edit_comment', {
        forum_name: comment.submission.forum.name,
        submission_id: comment.submission.id,
        comment_id: comment.id,
      }) }}" class="comment__edit-link {{ comment_nav_classes }}">
        {{- 'menu-item' in comment_nav_classes ? icon('pencil') }}
        {{ 'comments.edit'|trans -}}
      </a>
    </li>
  {% endif -%}
{% endblock comment_nav_edit %}

{% block comment_nav_ban %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('moderator', comment.submission.forum) %}
    <li>
      <a href="{{ path('forum_ban', {forum_name: comment.submission.forum.name, username: comment.user.username}) }}"
         class="comment__ban-link menu-item no-wrap">
        {{- icon('user-times') }}
        {{ 'action.ban'|trans -}}
      </a>
    </li>
  {% endif %}
{% endblock comment_nav_ban %}

{%- block comment_nav_ip_ban %}
  {% from '_macros/icon.html.twig' import icon %}
  {% if is_granted('ROLE_ADMIN') %}
    <li>
      <a href="{{ path('ban_user', {'username': comment.user.username}) }}"
         class="comment__ip-ban-link menu-item no-wrap">
        {{- icon('hammer') }}
        {{ 'action.global_ban'|trans -}}
      </a>
    </li>
  {% endif -%}
{% endblock comment_nav_ip_ban -%}
